package dev.inmo.postssystem.features.roles.common

import dev.inmo.postssystem.features.users.common.UserId
import kotlinx.serialization.Serializable
import kotlinx.serialization.builtins.ListSerializer

const val usersRolesRootPathPart = "roles"

val UsersIdsSerializer = ListSerializer(UserId.serializer())

const val usersRolesUserRoleQueryParameterName = "userRole"
const val usersRolesUserIdQueryParameterName = "userId"

const val usersRolesGetUsersPathPart = "getUsersByRole"
const val usersRolesGetRolesPathPart = "getUserRoles"
const val usersRolesContainsPathPart = "contains"
const val usersRolesContainsAnyPathPart = "containsAny"

const val usersRolesIncludePathPart = "include"
const val usersRolesExcludePathPart = "exclude"

@Serializable
data class UserRolesStorageIncludeExcludeWrapper<T : UserRole>(
    val userId: UserId,
    val userRole: T
)
