package dev.inmo.postssystem.features.roles.common

import dev.inmo.postssystem.features.users.common.UserId

interface ReadUsersRolesStorage<T : UserRole> {
    suspend fun getUsers(userRole: T): List<UserId>
    suspend fun getRoles(userId: UserId): List<T>
    suspend fun contains(userId: UserId, userRole: T): Boolean
    suspend fun containsAny(userId: UserId, userRoles: List<T>): Boolean
}
interface WriteUsersRolesStorage<T : UserRole> {
    suspend fun include(userId: UserId, userRole: T): Boolean
    suspend fun exclude(userId: UserId, userRole: T): Boolean
}

interface UsersRolesStorage<T : UserRole> : ReadUsersRolesStorage<T>, WriteUsersRolesStorage<T>
