package dev.inmo.postssystem.features.roles.common.keyvalue

import dev.inmo.postssystem.features.roles.common.*
import kotlinx.serialization.KSerializer
import kotlinx.serialization.StringFormat

open class KeyValueUsersRolesStorage<T : UserRole>(
    private val keyValuesRepo: KeyValuesUsersRolesOriginalRepo,
    private val serializer: KSerializer<T>,
    private val format: StringFormat = ReadKeyValueUsersRolesStorage.defaultJson
) : UsersRolesStorage<T>,
    ReadUsersRolesStorage<T> by ReadKeyValueUsersRolesStorage(keyValuesRepo, serializer, format),
    WriteUsersRolesStorage<T> by WriteKeyValueUsersRolesStorage(keyValuesRepo, serializer, format)
