package dev.inmo.postssystem.features.roles.manager.common

import dev.inmo.postssystem.features.roles.common.UserRole
import dev.inmo.postssystem.features.roles.common.UserRoleSerializer
import dev.inmo.micro_utils.serialization.typed_serializer.TypedSerializer
import kotlinx.serialization.Serializable

@Serializable(RolesManagerRoleSerializer::class)
interface RolesManagerRole : UserRole {
    companion object {
        fun serializer() = RolesManagerRoleSerializer
    }
}

@Serializable
object GeneralRolesManagerRole : RolesManagerRole {
    override fun toString(): String = "GeneralRolesManagerRole"
}

private const val KEY = "roles_manager"

object RolesManagerRoleSerializer : TypedSerializer<RolesManagerRole>(
    RolesManagerRole::class,
    mapOf(
        "${KEY}_general" to GeneralRolesManagerRole.serializer()
    )
) {
    init {
        UserRoleSerializer.includeSerializer(KEY, RolesManagerRoleSerializer)
        serializers.forEach { (k, v) -> UserRoleSerializer.includeSerializer(k, v) }
    }
}
