package dev.inmo.postssystem.server

import dev.inmo.micro_utils.ktor.server.configurators.ApplicationRoutingConfigurator
import io.ktor.application.call
import io.ktor.http.content.files
import io.ktor.http.content.static
import io.ktor.response.respondRedirect
import io.ktor.routing.Route
import io.ktor.routing.get
import java.io.File

class ClientStaticRoutingConfiguration(
    clientStatic: String?
) : ApplicationRoutingConfigurator.Element {
    private val staticFile = clientStatic ?.let { File(clientStatic).takeIf { it.exists() } }
    override fun Route.invoke() {
        staticFile ?.let {
            static("client") {
                files(it)
                get {
                    call.respondRedirect("client/index.html")
                }
            }
            get {
                call.respondRedirect("client")
            }
        }
    }
}
